import React from "react";
import { inject, observer } from "mobx-react";
import { IntlProvider, addLocaleData } from "react-intl";

import enLocale from 'react-intl/locale-data/en';
import deLocale from 'react-intl/locale-data/de';
addLocaleData([].concat(deLocale, enLocale));

var MobxIntlProviderChild = function MobxIntlProviderChild(_ref) {
    var locale = _ref.locale,
        children = _ref.children;

    var loc = locale.value;
    var messages = locale.messages;
    return React.createElement(
        IntlProvider,
        { key: loc, defaultLocale: "de", locale: loc, messages: messages },
        children
    );
};

export var MobxIntlProvider = inject("locale")(observer(MobxIntlProviderChild));